ALTER TABLE query_queue ADD lsfilter VARCHAR NOT NULL;

CREATE OR REPLACE FUNCTION create_table_function( tbl_date TIMESTAMP )
RETURNS CHAR(30) AS $$
DECLARE
table_name CHAR(30);
_hour CHAR(2);
_starttime timestamp;
_endtime timestamp;
BEGIN
	table_name := message_table_name(tbl_date);
	IF EXISTS (
		SELECT *
		FROM   pg_catalog.pg_tables 
		WHERE    tablename  = table_name
		) THEN
		RETURN table_name;
	ELSE
		_hour := (select extract(hour from tbl_date::timestamp))::text;
		_starttime := (select tbl_date::date::text || ' ' || _hour || ':00' )::timestamp;
		_endtime := (select tbl_date::date::text || ' ' || _hour || ':00' )::timestamp + interval '1 hour'; 
		EXECUTE ( 'CREATE TABLE '
			|| quote_ident(table_name)
			|| ' ( CHECK ( rtime < '
			|| quote_literal(_endtime)
			|| ' AND rtime >= '
			|| quote_literal(_starttime)
			|| '), PRIMARY KEY (id, rtime)
		) INHERITS (messages);' );
		PERFORM partition_maintenance_function();
	END IF;
	RETURN table_name;
END;
$$
LANGUAGE plpgsql;

--UPDATE db VERSION
UPDATE service SET version = 19;