CREATE OR REPLACE FUNCTION partition_maintenance_function()
RETURNS INTEGER AS $$
DECLARE
_count INTEGER;
_keep_hours INTEGER;
_lower_bound TIMESTAMP;
_result RECORD;
BEGIN
	_keep_hours := (SELECT keep_in_db+1 FROM settings);
	_lower_bound := (localtimestamp - ( _keep_hours || ' hours')::interval)::timestamp;
	_count = 0;
	FOR _result IN (SELECT table_name from information_schema.tables
		WHERE table_catalog = 'op5lsu'
		AND table_name LIKE E'messages\_%') LOOP
		IF  char_length(substring(_result.table_name from '[0-9_]*$')) <> 0 AND
			(_lower_bound > to_timestamp(substring(_result.table_name from '[0-9_]*$'), 'YYYY_MM_DD_HH24')) THEN
			EXECUTE 'DROP TABLE ' || quote_ident(_result.table_name);
			_count = _count + 1;
		END IF;
	END LOOP;
	RETURN _count;
END
$$
LANGUAGE plpgsql;

UPDATE service SET version = 26;
