CREATE OR REPLACE FUNCTION create_table_function( tbl_date INTEGER )
RETURNS CHAR(30) AS $$
DECLARE
table_name CHAR(30);
_hour integer;
_starttime integer;
_endtime integer;
BEGIN
	table_name := message_table_name(tbl_date);
	IF EXISTS (
		SELECT *
		FROM   pg_catalog.pg_tables
		WHERE    tablename  = table_name
		) THEN
		RETURN table_name;
	ELSE
		_hour := (select extract(hour from (select TIMESTAMP 'epoch' + tbl_date * INTERVAL '1 second')));
		_starttime := (select extract (epoch FROM (((select TIMESTAMP 'epoch' + tbl_date * INTERVAL '1 second')::date + _hour * INTERVAL '1 hour')::timestamp at time zone 'UTC')));
		_endtime := (select _starttime + 3600);
		EXECUTE ( 'CREATE TABLE '
			|| quote_ident(table_name)
			|| ' ( CHECK ( rtime < '
			|| _endtime
			|| ' AND rtime >= '
			|| _starttime
			|| '), PRIMARY KEY (id, rtime)
		) INHERITS (messages);' );
	END IF;
	RETURN table_name;
END;
$$
LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION message_table_name( tbl_date INTEGER )
RETURNS CHAR(30) AS $$
DECLARE
the_hour CHAR(2);
BEGIN
	the_hour := (select extract(hour from (select TIMESTAMP 'epoch' + tbl_date * INTERVAL '1 second')))::text;
	IF (the_hour::int < 10) THEN
		the_hour := '0'||the_hour::text;
	END IF;

	RETURN 'messages_' || REPLACE(((select TIMESTAMP 'epoch' + tbl_date * INTERVAL '1 second')::date)::text, '-','_') || '_' || the_hour::text;
END;
$$
LANGUAGE plpgsql;

UPDATE service SET version = 29;
